unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Mask, ToolEdit, Buttons, ExtCtrls, Jpeg, Animate,
  GIFCtrl, CheckLst, Gauges, mmSystem, RxGIF;

type
  TForm1 = class(TForm)
    m1: TMemo;
    m2: TMemo;
    m3: TMemo;
    Label1: TLabel;
    bget: TBitBtn;
    dir: TDirectoryEdit;
    Go: TBitBtn;
    Label3: TLabel;
    Label4: TLabel;
    mask: TEdit;
    dir2: TDirectoryEdit;
    Label5: TLabel;
    dir3: TDirectoryEdit;
    Label6: TLabel;
    bLoad: TBitBtn;
    bSave: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    o1: TOpenDialog;
    anim: TRxGIFAnimator;
    sd1: TSaveDialog;
    rb1: TRadioButton;
    cb3: TCheckBox;
    cb4: TCheckBox;
    rb2: TRadioButton;
    e2: TEdit;
    Label2: TLabel;
    Label8: TLabel;
    e3: TEdit;
    lb: TListBox;
    pb: TGauge;
    Bevel1: TBevel;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Label7: TLabel;
    cb1: TCheckBox;
    e1: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    cb2: TCheckBox;
    e4: TEdit;
    e5: TEdit;
    cb5: TCheckBox;
    Label11: TLabel;
    e6: TEdit;
    e7: TEdit;
    Label12: TLabel;
    Button4: TButton;
    TabSheet5: TTabSheet;
    Image1: TImage;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Image5: TImage;
    Timer1: TTimer;
    fname: TEdit;
    Label23: TLabel;
    TabSheet6: TTabSheet;
    CreatePrev: TCheckBox;
    Label25: TLabel;
    Label24: TLabel;
    Label26: TLabel;
    rb5: TRadioButton;
    rb6: TRadioButton;
    Label27: TLabel;
    ewi: TEdit;
    Label28: TLabel;
    ehe: TEdit;
    cl1: TComboBox;
    TrackBar1: TTrackBar;
    cl2: TComboBox;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Bevel2: TBevel;
    cb7: TCheckBox;
    i: TLabel;
    Label33: TLabel;
    dir4: TDirectoryEdit;
    procedure dirChange(Sender: TObject);
    procedure bgetClick(Sender: TObject);
    procedure cb1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure GoClick(Sender: TObject);
    procedure bLoadClick(Sender: TObject);
    procedure bSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure e1Change(Sender: TObject);
    procedure rb1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure dirAfterDialog(Sender: TObject; var Name: String;
      var Action: Boolean);
    procedure cb5Click(Sender: TObject);
    procedure cb2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Label21Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Label25Click(Sender: TObject);
    procedure CreatePrevClick(Sender: TObject);
    procedure cl1Change(Sender: TObject);
    procedure ewiKeyPress(Sender: TObject; var Key: Char);
    procedure TrackBar1Change(Sender: TObject);
    procedure cl2Change(Sender: TObject);
    procedure iClick(Sender: TObject);
  private
    Function sTeg(s: AnsiString; j: Integer): AnsiString; //     ,  
    Function StTag(const s: AnsiString): AnsiString; // ||   ,   
    Function FiTag(const s: AnsiString): AnsiString; // ||   ,   
    Function PaStr(const s: AnsiString; page: Integer): AnsiString; //     ( ||  )
    Function CreatePreview(const fn, outputfile: AnsiString): AnsiString;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1 : TForm1;
  pg    : Integer;
  MyName: String;

implementation

uses Unit2, ShellAPI, ID3v1, ID3v2;

{$R *.DFM}

procedure TForm1.dirChange(Sender: TObject);
begin
  if dir.Text<>'' then bGet.Enabled:=True;
  lb.Clear;
  if tag=1 then begin
    Tag:=0;
    dir2.text:=dir.text;
    dir3.text:=dir.text;
  end;
end;

procedure TForm1.bgetClick(Sender: TObject);
var SearchRec        : TSearchRec;
begin
  lb.Clear;
  if dir.text[length(dir.text)]<>'\' then dir.text:=dir.text+'\';
  if (dir2.text<>'') and (dir2.text[length(dir2.text)]<>'\') then dir2.text:=dir2.text+'\';
  FindFirst(dir.text+mask.text, faAnyFile, SearchRec);
  if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') then if (SearchRec.Attr<>16) and (SearchRec.Name<>'') then begin
    lb.items.Add(SearchRec.Name);
  end;
  if FindNext(SearchRec) = 0 then begin
   repeat
     if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') and (SearchRec.Name<>'') then if (SearchRec.Attr<>16) then begin
       lb.items.Add(SearchRec.Name);
     end;
     application.ProcessMessages;
   until FindNext(SearchRec) <> 0;
  end;
  FindClose(SearchRec);
  if lb.Items.Count<>0 then Go.enabled:=True; 
end;

procedure TForm1.cb1Click(Sender: TObject);
begin
  e1.Enabled:=cb1.Checked;
  label7.Enabled:=cb1.Checked;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if o1.Execute then m1.Lines.LoadFromFile(o1.FileName);
  Button8.Enabled:=False;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if o1.Execute then m2.Lines.LoadFromFile(o1.FileName);
  Button8.Enabled:=False;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if o1.Execute then m3.Lines.LoadFromFile(o1.FileName);
  Button8.Enabled:=False;
end;

procedure TForm1.GoClick(Sender: TObject);
var i,m,n          : Integer;
    f              : TextFile;
    err            : Boolean;

begin
  pb.Progress:=0;
  pb.MinValue:=0;
  pb.ShowText:=True;
  if Trim(fname.text)='' then fname.Text:='page';
  if (dir.text<>'') and (dir.text[length(dir.text)]<>'\') then dir.text:=dir.text+'\';
  if (dir2.text<>'') and (dir2.text[length(dir2.text)]<>'\') then dir2.text:=dir2.text+'\';
  if (dir3.text<>'') and (dir3.text[length(dir3.text)]<>'\') then dir3.text:=dir3.text+'\';
  if (dir4.text<>'') and (dir4.text[length(dir4.text)]<>'\') then dir4.text:=dir4.text+'\';
  err:=False;
  if lb.Items.Count=0 then
    if dir.text<>'' then bGetClick(Self) else begin
      MessageDLG('Can''t create files list. Please fill field ''From''.',mtError,[mbOk],0);
    end else begin

  if lb.SelCount>0 then
    for i:=lb.Items.Count-1 downto 0 do if NOT lb.Selected[i] then lb.Items.Delete(i);

  pb.maxValue:=lb.Items.Count-1;
  e1.Text:=IntToStr(StrToIntDef(e1.text,999));

  pg:=0;
  m:=-1;
  n:=-1;
  repeat
    m:=m+1;
    n:=n+1;
    pb.Progress:=m;
    application.ProcessMessages;
    if (n=0) or ((n=StrToInt(e1.text)+1) and (cb1.Checked)) then begin

      if pg<>0 then begin //    ,    
        for i:=0 to m3.Lines.Count-1 do Writeln(f,sTeg(m3.Lines[i],m));
        CloseFile(f);
        if m>=lb.Items.Count then pg:=-1; //m -    
      end;

      if pg<>-1 then begin //  ,    
        AssignFile(f,dir3.text+fname.Text+IntToStr(pg)+'.html');
        {$I-}Rewrite(f);{$I+}
        if IOResult<>0 then begin
          err:=True;    // ,   
          MessageDLG('Can''t create file '''+dir3.text+fname.Text+IntToStr(pg)+'.html''. ',mtError,[mbOk],0);
        end else begin
          pg:=pg+1;   //  
          n:=1;       //   
          // ;)
          Writeln(f,'<!-- This file was created by Cool Listing Creator. TiGER grp. http://dimonius.da.ru -->');
          // 
          for i:=0 to m1.Lines.Count-1 do Writeln(f,sTeg(m1.Lines[i],m));
        end;
      end;
    end;

    //  ,        
    //   ,   .
    if NOT err and (pg<>-1) and (Form2.cb1.Checked) and
       (m<>0) and (StrToIntDef(Form2.e1.text,999)<>0) and
       (n>1) and
       (m mod StrToIntDef(Form2.e1.text,999)=0) then begin
       application.ProcessMessages;
       for i:=0 to Form2.pm1.Lines.Count-1 do Writeln(f,sTeg(Form2.pm1.Lines[i],m));
    end;

    //   
    if NOT err and (pg<>-1) then begin
       application.ProcessMessages;
       for i:=0 to m2.Lines.Count-1 do Writeln(f,sTeg(m2.Lines[i],m));
    end;

    //      
    if NOT err and (pg<>-1) and (Form2.cb2.Checked) and
       (m<>0) and (StrToIntDef(Form2.e2.text,999)<>0) and
       (n>1) and
       (m mod StrToIntDef(Form2.e2.text,999)=0) then begin
       application.ProcessMessages;
       for i:=0 to Form2.pm2.Lines.Count-1 do Writeln(f,sTeg(Form2.pm2.Lines[i],m));
    end;

  until (m>=lb.Items.Count-1) or err;

  if pg>0 then begin
     for i:=0 to m3.Lines.Count-1 do Writeln(f,sTeg(m3.Lines[i],m));
     CloseFile(f);
  end;

  pb.ShowText:=False;
  pb.Progress:=0;
  PlaySound('SystemAsterisk',0,snd_Async);
  Button8.Enabled:=True;
  end;
end;

Function TForm1.sTeg(s: AnsiString; j: Integer): AnsiString;
var i            : Integer;
    s2           : AnsiString;
    allpag       : Integer;
    f2           : File;
    x,y          : Integer;
    im           : TPicture;
    siz          : Real;
    oldmode      : Byte;
    fprev        : AnsiString;

    ID3v1        : TID3v1;
    ID3v2        : TID3v2;

  // 2    
  function GetMp3Real(const v1,v2: Boolean; const s1,s2: AnsiString): AnsiString;
  begin
    Result:='';
    if v2 and (length(Trim(s2))>0) then Result:=s2 else
      if v1 then Result:=s1;
  end;

  function CheckMP3(): Boolean;
  begin
    if Assigned(ID3v1) then begin
      Result:=True;
      exit;
    end;
    if (LowerCase(ExtractFileExt(lb.Items[j]))<>'.mp3') then begin
      Result:=False;
      exit;
    end;

    Result:=True;
    ID3v1:=TID3v1.Create;
    ID3v2:=TID3v2.Create;
    try
      ID3v1.ReadFromFile(dir.text+lb.Items[j]);
      ID3v2.ReadFromFile(dir.text+lb.Items[j]);
    except
      ID3v1.Free;
      ID3v2.Free;
      ID3v1:=nil;
      ID3v2:=nil;
      Result:=False;
    end;
  end;



begin
  ID3v1:=nil;
  ID3v2:=nil;

  try
    if cb2.Checked and cb1.Checked then
      if lb.Items.Count mod StrToIntDef(e1.Text,999)=0 then allpag:=Trunc(lb.Items.Count/StrToIntDef(e1.Text,999)) else allpag:=Trunc(lb.Items.Count/StrToIntDef(e1.Text,999))+1
    else allpag:=0;

    i:=0;
    repeat
      i:=i+1;
      if LowerCase(copy(s,i,6))='<file>' then begin
        delete(s,i,6);
        s2:='';
        if rb1.Checked then begin
          if cb3.Checked then s2:=dir.text+lb.Items[j] else s2:=lb.Items[j];
        end;
        if rb2.Checked then s2:=e2.text+lb.Items[j];
        insert(s2,s,i);
      end else
      if LowerCase(copy(s,i,6))='<prev>' then begin
        delete(s,i,6);
        s2:=LowerCase(ExtractFileExt(lb.Items[j]));
        if (s2='.jpg') or (s2='.gif') or (s2='.bmp') or (s2='.wmf') then begin
          fprev:=dir2.text+lb.Items[j];
          if CreatePrev.Checked then //   
            if (rb5.Checked and (NOT FileExists(dir2.text+lb.Items[j]))) or //   
               (rb6.Checked) then fprev:=CreatePreview(dir.text+lb.Items[j],dir2.text+lb.Items[j]);     //   

          s2:='';
          im:=TPicture.Create;
          try
            im.LoadFromFile(fprev);
            x:=im.Width;
            y:=im.Height;
          except
            x:=0;
            y:=0;
          end;
          im.Free;

          if (x<>0) and (y<>0) then begin
            if rb1.Checked then begin //     
              if cb4.Checked then s2:='<IMG SRC="'+dir.text+ExtractFileName(fprev)+'" '
                 else s2:='<IMG SRC="'+ExtractFileName(fprev)+'" ';
            end;
            if rb2.Checked then s2:='<IMG SRC="'+e3.text+ExtractFileName(fprev)+'" ';
            s2:=s2+'WIDTH="'+IntToStr(x)+'" HEIGHT="'+IntToStr(y)+'" BORDER=0>';
            insert(s2,s,i);
          end;
        end else
          if cb7.Checked then begin  //   jpg, gif  bmp
            fprev:=LowerCase(ExtractFileExt(lb.Items[j]));
            delete(fprev,1,1);
            if FileExists(dir4.Text+fprev+'.gif') then fprev:=fprev+'.gif' else
            if FileExists(dir4.Text+fprev+'.jpg') then fprev:=fprev+'.jpg' else
            if FileExists(dir4.Text+fprev+'.bmp') then fprev:=fprev+'.bmp' else
              fprev:='';

            if fprev<>'' then begin
              im:=TPicture.Create;
              try
                im.LoadFromFile(fprev);
                x:=im.Width;
                y:=im.Height;
              except
                x:=0;
                y:=0;
              end;
              im.Free;
            end else begin
              x:=0;
              y:=0;
            end;  


            if (x<>0) and (y<>0) then begin
              if rb1.Checked then begin //     
                if cb4.Checked then s2:='<IMG SRC="'+dir.text+ExtractFileName(fprev)+'" '
                   else s2:='<IMG SRC="'+ExtractFileName(fprev)+'" ';
              end;
              if rb2.Checked then s2:='<IMG SRC="'+e3.text+ExtractFileName(fprev)+'" ';
              s2:=s2+'WIDTH="'+IntToStr(x)+'" HEIGHT="'+IntToStr(y)+'" BORDER=0>';
              insert(s2,s,i);
            end;
          end;
      end else
      if LowerCase(copy(s,i,7))='<fname>' then begin
        delete(s,i,7);
        insert(lb.Items[j],s,i);
      end else
      if LowerCase(copy(s,i,8))='<fname_>' then begin
        delete(s,i,8);
        x:=length(lb.Items[j])+1;
        repeat
          x:=x-1;
        until (x<=1) or (lb.Items[j][x]='.');
        if x<=1 then x:=length(lb.Items[j])+1;
        insert(copy(lb.Items[j],1,x-1),s,i);
      end else
      if LowerCase(copy(s,i,7))='<fext_>' then begin
        delete(s,i,7);
        x:=length(lb.Items[j])+1;
        repeat
          x:=x-1;
        until (x<=1) or (lb.Items[j][x]='.');
        if x<=1 then x:=length(lb.Items[j]);
        insert(copy(lb.Items[j],x+1,length(lb.Items[j])),s,i);
      end else
      if LowerCase(copy(s,i,7))='<psize>' then begin
        delete(s,i,7);
        s2:=LowerCase(ExtractFileExt(lb.Items[j]));
        if (s2='.jpg') or (s2='.gif') or (s2='.bmp') or (s2='.wmf') then begin
          oldmode := FileMode;
          FileMode := 0; //read-only access
          AssignFile(f2,dir2.text+lb.Items[j]);
          {$I-}reset(f2,1);
          siz:=FileSize(f2)/1000;
          FileMode:=oldmode;
          {$I+}
          if IOResult=0 then begin s2:=FloatToStr(siz); CloseFile(f2) end else s2:='???';
          if s2<>'???' then begin
             y:=length(s2)+1;
             repeat
               y:=y-1;
               delete(s2,y,1);
             until (y<=2) or (s2[y-2]=',');
          end;
          insert(s2,s,i);
        end;
      end else
      if LowerCase(copy(s,i,7))='<fsize>' then begin
        delete(s,i,7);
        oldmode := FileMode;
        FileMode := 0; //read-only access
        AssignFile(f2,dir.text+lb.Items[j]);
        {$I-}reset(f2,1);
        siz:=FileSize(f2)/1000;
        FileMode:=oldmode;
        {$I+}
        if IOResult=0 then begin s2:=FloatToStr(siz); CloseFile(f2) end else s2:='???';
        if s2<>'???' then begin
           y:=length(s2)+1;
           repeat
             y:=y-1;
             delete(s2,y,1);
           until (y<=2) or (s2[y-2]=',');
        end;
        insert(s2,s,i);
      end else
      if LowerCase(copy(s,i,6))='<link>' then begin
        delete(s,i,6);
        if allpag>1 then begin
          s2:=StTag(e5.text)+'[&nbsp;';
          for x:=1 to allpag do
            if x=pg then begin
               s2:=s2+StTag(e7.text)+PaStr(e4.text,x)+FiTag(e7.text)+'&nbsp;';
               if x<>allpag then s2:=s2+'|&nbsp;';
            end else begin
               s2:=s2+'<A HREF="'+fname.text+IntToStr(x-1)+'.html">'+StTag(e6.text)+PaStr(e4.text,x)+FiTag(e6.text)+'</A>&nbsp;';
               if x<>allpag then s2:=s2+'|&nbsp;';
            end;
          s2:=s2+'&nbsp;]'+FiTag(e5.text);
          insert(s2,s,i);
        end;
      end else
      if LowerCase(copy(s,i,9))='<pnumber>' then begin
        delete(s,i,9);
        insert(IntToStr(pg),s,i);
      end else
      if LowerCase(copy(s,i,7))='<pprev>' then begin
        delete(s,i,7);
        insert(IntToStr(pg-1),s,i);
      end else
      if LowerCase(copy(s,i,7))='<pnext>' then begin
        delete(s,i,7);
        insert(IntToStr(pg+1),s,i);
      end else

      if LowerCase(copy(s,i,10))='<nextfile>' then begin
        delete(s,i,10);
        if pg<allpag then insert(fname.Text+IntToStr(pg)+'.html',s,i);
      end else
      if LowerCase(copy(s,i,10))='<prevfile>' then begin
        delete(s,i,10);
        if pg>1 then insert(fname.Text+IntToStr(pg-2)+'.html',s,i);
      end else

      if LowerCase(copy(s,i,9))='<fnumber>' then begin
        delete(s,i,9);
        insert(IntToStr(j+1),s,i);
      end else
      if LowerCase(copy(s,i,7))='<fprev>' then begin
        delete(s,i,7);
        insert(IntToStr(j),s,i);
      end else
      if LowerCase(copy(s,i,7))='<fnext>' then begin
        delete(s,i,7);
        insert(IntToStr(j+2),s,i);
      end else
      if LowerCase(copy(s,i,8))='<pcount>' then begin
        delete(s,i,8);
        insert(IntToStr(allpag),s,i);
      end else
      if LowerCase(copy(s,i,8))='<fcount>' then begin
        delete(s,i,8);
        insert(IntToStr(lb.Items.Count),s,i);
      end else
      if LowerCase(copy(s,i,8))='<pardir>' then begin
        delete(s,i,8);
        s2:=ExtractFilePath(dir.text+lb.Items[j]);
        if (length(s2)>0) and (s2[length(s2)]<>'\') then s2:=s2+'\';
        s2:=ExtractFileName(copy(s2,1,length(s2)-1));
        insert(s2,s,i);
      end else
      if LowerCase(copy(s,i,10))='<mp3title>' then begin
        delete(s,i,10);
        if CheckMP3 then
          insert(GetMp3Real(ID3v1.Exists, ID3v2.Exists, ID3v1.Title, ID3v2.Title), s, i);
      end else
      if LowerCase(copy(s,i,11))='<mp3artist>' then begin
        delete(s,i,11);
        if CheckMP3 then
          insert(GetMp3Real(ID3v1.Exists,ID3v2.Exists,ID3v1.Artist,ID3v2.Artist), s, i);
      end else
      if LowerCase(copy(s,i,10))='<mp3album>' then begin
        delete(s,i,10);
        if CheckMP3 then
          insert(GetMp3Real(ID3v1.Exists,ID3v2.Exists,ID3v1.Album,ID3v2.Album), s, i);
      end else
      if LowerCase(copy(s,i,9))='<mp3year>' then begin
        delete(s,i,9);
        if CheckMP3 then
          insert(GetMp3Real(ID3v1.Exists,ID3v2.Exists,ID3v1.Year,ID3v2.Year), s, i);
      end else
      if LowerCase(copy(s,i,12))='<mp3comment>' then begin
        delete(s,i,12);
        if CheckMP3 then
          insert(GetMp3Real(ID3v1.Exists,ID3v2.Exists,ID3v1.Comment,ID3v2.Comment), s, i);
      end else
      if LowerCase(copy(s,i,10))='<mp3track>' then begin
        delete(s,i,10);
        if CheckMP3 then
          insert(GetMp3Real(ID3v1.Exists,ID3v2.Exists,IntToStr(ID3v1.Track),IntToStr(ID3v2.Track)), s, i);
      end else
      if LowerCase(copy(s,i,10))='<mp3genre>' then begin
        delete(s,i,10);
        if CheckMP3 then
          insert(GetMp3Real(ID3v1.Exists,ID3v2.Exists,ID3v1.Genre,ID3v2.Genre), s, i);
      end else
      if LowerCase(copy(s,i,13))='<mp3composer>' then begin
        delete(s,i,13);
        if CheckMP3 then
          insert(ID3v2.Composer, s, i);
      end else
      if LowerCase(copy(s,i,12))='<mp3encoder>' then begin
        delete(s,i,12);
        if CheckMP3 then
          insert(ID3v2.Encoder, s, i);
      end else
      if LowerCase(copy(s,i,14))='<mp3copyright>' then begin
        delete(s,i,14);
        if CheckMP3 then
          insert(ID3v2.Copyright, s, i);
      end else
      if LowerCase(copy(s,i,13))='<mp3language>' then begin
        delete(s,i,13);
        if CheckMP3 then
          insert(ID3v2.Language, s, i);
      end else
      if LowerCase(copy(s,i,9))='<mp3link>' then begin
        delete(s,i,9);
        if CheckMP3 then
          insert(ID3v2.Link, s, i);
      end;

    until i>=length(s);
    Result:=s;
  finally
    if Assigned(ID3v1) then ID3v1.Free;
    if Assigned(ID3v2) then ID3v2.Free;
  end;
end;

procedure TForm1.bLoadClick(Sender: TObject);
var fi    : String;
    f     : TextFile;
    s     : AnsiString;
    n     : Byte;
begin
  Button8.Enabled:=False;
  fi:=o1.Filter;
  o1.Filter:='Cool Listing Maker Files|*.clm|All Files (*.*)|*.*';
  if o1.Execute then begin
    m1.Clear;
    m2.Clear;
    m3.Clear;
    Form2.pm1.Clear;
    Form2.pm2.Clear;
    AssignFile(f,o1.FileName);
    {$I-}reset(f);{$I+}
    if IOResult=0 then begin
       readln(f,s);
       if s='Cool Listing Maker Configuration File. Made by SimBa aka Dimoniusis. TiGER grp. http://dimonius.da.ru' then begin
          readln(f,s);
          dir.Text:=s;
          readln(f,s);
          mask.Text:=s;
          readln(f,s);
          dir2.Text:=s;
          readln(f,s);
          dir3.Text:=s;
          readln(f,s);
          e1.Text:=s;
          readln(f,s);
          e2.Text:=s;
          readln(f,s);
          e3.Text:=s;
          readln(f,s);
          e4.Text:=s;
          readln(f,s);
          e5.Text:=s;
          readln(f,s);
          e6.Text:=s;
          readln(f,s);
          e7.Text:=s;
          readln(f,s);
          fname.Text:=s;


          readln(f,s);
          Form2.e1.Text:=s;
          readln(f,s);
          Form2.e2.Text:=s;


          readln(f,s);
          cb1.Checked:=s[1]='1';
          readln(f,s);
          cb2.Checked:=s[1]='1';
          readln(f,s);
          cb3.Checked:=s[1]='1';
          readln(f,s);
          cb4.Checked:=s[1]='1';
          readln(f,s);
          cb5.Checked:=s[1]='1';
          rb1.Checked:=False;
          rb2.Checked:=False;
          readln(f,s);
          rb1.Checked:=s[1]='1';
          rb2.Checked:=NOT rb1.Checked;

          readln(f,s);
          Form2.cb1.Checked:=s[1]='1';
          readln(f,s);
          Form2.cb2.Checked:=s[1]='1';

          n:=0;
          repeat
            readln(f,s);
            if s='----------------' then n:=n+1;
            if (n=0) and (s<>'----------------') then m1.Lines.Add(s);
            if (n=1) and (s<>'----------------') then m2.Lines.Add(s);
            if (n=2) and (s<>'----------------') then m3.Lines.Add(s);

            if (n=3) and (s<>'----------------') then Form2.pm1.Lines.Add(s);
            if (n=4) and (s<>'----------------') then Form2.pm2.Lines.Add(s);
          until EOF(f);
          CloseFile(f);
       end else MessageDLG('Error Configuration file '''+o1.FileName+'''',mtError,[mbOk],0);
    end else MessageDLG('Can''t open file '''+o1.FileName+'''',mtError,[mbOk],0);
  end;
  o1.Filter:=fi;
end;

procedure TForm1.bSaveClick(Sender: TObject);
var f     : TextFile;
    i     : Integer;
begin
  if sd1.Execute then begin
    if extractFileExt(sd1.FIleName)='' then sd1.FileName:=sd1.FileName+'.clm';
    AssignFile(f,sd1.FileName);
    {$I-}rewrite(f);{$I+}
    if IOResult=0 then begin
       Writeln(f,'Cool Listing Maker Configuration File. Made by SimBa aka Dimoniusis. TiGER grp. http://dimonius.da.ru');

       writeln(f,dir.Text);
       writeln(f,mask.Text);
       writeln(f,dir2.Text);
       writeln(f,dir3.Text);
       writeln(f,e1.Text);
       writeln(f,e2.Text);
       writeln(f,e3.Text);
       writeln(f,e4.Text);
       writeln(f,e5.Text);
       writeln(f,e6.Text);
       writeln(f,e7.Text);
       writeln(f,fname.Text);
       writeln(f,Form2.e1.Text);
       writeln(f,Form2.e2.Text);

       writeln(f,IntToStr(ord(cb1.checked)));
       writeln(f,IntToStr(ord(cb2.checked)));
       writeln(f,IntToStr(ord(cb3.checked)));
       writeln(f,IntToStr(ord(cb4.checked)));
       writeln(f,IntToStr(ord(cb5.checked)));
       writeln(f,IntToStr(ord(rb1.checked)));
       writeln(f,IntToStr(ord(Form2.cb1.checked)));
       writeln(f,IntToStr(ord(Form2.cb2.checked)));


       for i:=0 to m1.Lines.Count-1 do writeln(f,m1.lines[i]);
       writeln(f,'----------------');
       for i:=0 to m2.Lines.Count-1 do writeln(f,m2.lines[i]);
       writeln(f,'----------------');
       for i:=0 to m3.Lines.Count-1 do writeln(f,m3.lines[i]);

       With Form2 do begin
         writeln(f,'----------------');
         for i:=0 to pm1.Lines.Count-1 do writeln(f,pm1.lines[i]);
         writeln(f,'----------------');
         for i:=0 to pm2.Lines.Count-1 do writeln(f,pm2.lines[i]);
       end;

       CloseFile(f);
    end else MessageDLG('Can''t create file '''+o1.FileName+'''',mtError,[mbOk],0);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i,n: Integer;
begin
  MyName:=#84#105#109#111#43#110#134#46#98#121#126#84#116#52+
          #118#129#120#56#93#131#136#139#139#135#148#147#138+
          #149#81#68#121#143#110#109#123#74#146#158#157#92#79+
          #152#165#166#163#110#100#101#155#161#166#169#169#165+
          #178#177#109#164#162#112#181#185;
  for i:=1 to length(MyName) do MyName[i]:=chr(ord(MyName[i])-6-i);
  n:=0;
  for i:=1 to length(MyName) do n:=n+ord(MyName[i]);
  if n<>5463 then begin MessageDLG('.    EXE .'#10'   ',mtError,[mbOk],0);
  halt(0); end;

  Form1.Caption:=Form1.Caption+' v1.8 '+MyName;
  application.Title:='Cool Listing Maker. v1.8';

  Tag:=0;
  anim.Animate:=True;
  o1.InitialDir:=application.ExeName;
  sd1.InitialDir:=application.ExeName;
  dir.Text:=ExtractFilePath(Application.ExeName);
  dir2.Text:=ExtractFilePath(Application.ExeName);
  dir3.Text:=ExtractFilePath(Application.ExeName);
  dir4.Text:=ExtractFilePath(Application.ExeName);

  cl1.ItemIndex:=3;
  cl2.ItemIndex:=0;
end;

procedure TForm1.e1Change(Sender: TObject);
var s: String;
    i: Byte;
begin
  s:=e1.text;
  if (s<>'') and (NOT (s[e1.SelStart] in ['0'..'9'])) then begin
    delete(s,e1.SelStart,1);
    i:=e1.SelStart;
    e1.text:=s;
    e1.SelStart:=i;
  end;
end;

procedure TForm1.rb1Click(Sender: TObject);
begin
  if (sender is TLabel) then begin
    if (Sender as TLabel).name='Label13' then rb1.Checked:=True else
      rb2.Checked:=True; 
  end;
  cb3.Enabled:=rb1.Checked;
  label16.Enabled:=rb1.Checked;
  cb4.Enabled:=rb1.Checked;
  label15.Enabled:=rb1.Checked;
  label2.Enabled:=rb2.Checked;
  label8.Enabled:=rb2.Checked;
  e2.Enabled:=rb2.Checked;
  e3.Enabled:=rb2.Checked;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  anim.Animate:=True;
end;

procedure TForm1.FormDeactivate(Sender: TObject);
begin
  anim.Animate:=False;
  anim.FrameIndex:=0;
end;

procedure TForm1.dirAfterDialog(Sender: TObject; var Name: String;
  var Action: Boolean);
begin
  tag:=1;
end;

procedure TForm1.cb5Click(Sender: TObject);
begin
  lb.Sorted:=cb5.Checked;
end;

procedure TForm1.cb2Click(Sender: TObject);
begin
  Label9.Enabled:=cb2.Checked;
  Label10.Enabled:=cb2.Checked;
  Label11.Enabled:=cb2.Checked;
  Label12.Enabled:=cb2.Checked;
  e4.Enabled:=cb2.Checked;
  e5.Enabled:=cb2.Checked;
  e6.Enabled:=cb2.Checked;
  e7.Enabled:=cb2.Checked;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
//  Showmessage(IntToStr(pos('|',e7.text)));
  Form2.Show;
end;

function TForm1.FiTag(const s: AnsiString): AnsiString;
var k: Integer;
begin
  k:=pos('||',s);
  if k=0 then Result:='' else
    Result:=copy(s,k+2,length(s));
end;

function TForm1.StTag(const s: AnsiString): AnsiString;
var k: Integer;
begin
  k:=pos('||',s);
  if k=0 then k:=length(s);
  Result:=copy(s,1,k-1);
end;

function TForm1.PaStr(const s: AnsiString; page: Integer): AnsiString;
var k: Integer;
begin
  k:=pos('||',s);
  if k=0 then Result:=s+' '+IntToStr(page) else
    Result:=copy(s,1,k-1)+IntToStr(page)+copy(s,k+2,length(s));
end;

procedure TForm1.Label21Click(Sender: TObject);
begin
  if (Sender as TLabel).Caption='http://dimonius.da.ru' then
    ShellExecute(Handle,'open','http://dimonius.da.ru',nil,nil,SW_SHOWNORMAL)
  else
    ShellExecute(Handle,'open','mailto:dimonius@operamail.com',nil,nil,SW_SHOWNORMAL)
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  ShellExecute(handle,'open',PChar(dir3.text+fname.text+'0.html'),nil,nil,SW_SHOWNORMAL);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  m1.Clear;
  Button8.Enabled:=False;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  m2.Clear;
  Button8.Enabled:=False;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  m3.Clear;
  Button8.Enabled:=False;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  TabSheet1.show;
  Timer1.Enabled:=False;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  Image1.parent:=PageControl1.ActivePage;
  Image1.SendToBack;
  Image1.Invalidate;
end;

procedure TForm1.Label25Click(Sender: TObject);
begin
  CreatePrev.Checked:=NOT CreatePrev.Checked; 
end;

procedure TForm1.CreatePrevClick(Sender: TObject);
begin
  rb5.Enabled:=CreatePrev.Checked;
  rb6.Enabled:=CreatePrev.Checked;
  Label24.Enabled:=CreatePrev.Checked;
  Label26.Enabled:=CreatePrev.Checked;
end;

procedure TForm1.cl1Change(Sender: TObject);
begin
  case cl1.ItemIndex of
    0:begin
        ewi.Enabled:=True;
        ehe.Enabled:=False;
        if ewi.Text='Auto' then ewi.Text:='80';
        ehe.Text:='Auto';
      end;
    1:begin
        ewi.Enabled:=False;
        ehe.Enabled:=True;
        ewi.Text:='Auto';
        if ehe.Text='Auto' then ehe.Text:='60';
      end;
    2:begin
        ewi.Enabled:=True;
        ehe.Enabled:=True;
        if ewi.Text='Auto' then ewi.Text:='80';
        if ehe.Text='Auto' then ehe.Text:='60';
      end;
    3:begin
        ewi.Enabled:=True;
        ehe.Enabled:=False;
        if ewi.Text='Auto' then ewi.Text:='80';
        ehe.Text:='Auto';
      end;
  end;

{width
height
width+height
big size<int}

end;

procedure TForm1.ewiKeyPress(Sender: TObject; var Key: Char);
begin
  if NOT (key in ['0'..'9',#8]) then key:=#0;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  label31.Caption:=IntToStr(TrackBar1.Position)+'%';
end;

procedure TForm1.cl2Change(Sender: TObject);
begin
  Label30.Enabled:=(cl2.ItemIndex=1) or (cl2.ItemIndex=0);
  Label31.Enabled:=Label30.Enabled;
  TrackBar1.Enabled:=Label30.Enabled;
end;

procedure TForm1.iClick(Sender: TObject);
begin
  cb7.Checked:=NOT cb7.Checked;
end;

function TForm1.CreatePreview(const fn, outputfile: AnsiString): AnsiString;
var x,y,dx,dy: Integer;
          bmp: TBitmap;
           jp: TJpegImage;
           gi: TGIFImage;
           im: TPicture;
        forma: Byte;
begin
  Result:='';
  im:=TPicture.Create;
  try
    try
      im.LoadFromFile(fn);
      if ewi.Text='Auto' then x:=0 else
         x:=StrToIntDef(ewi.text,im.Width);
      if ehe.Text='Auto' then y:=0 else
         y:=StrToIntDef(ehe.text,im.Height);

      //  
      case cl1.ItemIndex of
        0:begin //width
            dx:=x;
            dy:=Trunc((x*im.Height)/im.width);
          end;
        1:begin //height
            dx:=Trunc((y*im.Width)/im.Height);
            dy:=y;
          end;
        2:begin //width & height
            dx:=x;
            dy:=y;
          end;
        3: //big size<value
           if x>y then begin
             dx:=x;
             dy:=Trunc((x*im.Height)/im.width);
           end else begin
             dx:=Trunc((y*im.Width)/im.Height);
             dy:=y;
           end;
        else begin
          dx:=0;
          dy:=0;
        end;

      end;

    if (dx>0) and (dy>0) then begin
      // 
      bmp:=TBitmap.Create;
      bmp.Width:=dx;
      bmp.Height:=dy;
      bmp.PixelFormat:=pf24bit;
      try
        //
        bmp.Canvas.StretchDraw(Rect(0,0,dx,dy),im.Graphic);

        forma:=cl2.ItemIndex; //    
        if forma=0 then begin //   -      
          if (LowerCase(ExtractFileExt(fn))='.jpg') or
             (LowerCase(ExtractFileExt(fn))='.jpeg') then forma:=1 else
          if (LowerCase(ExtractFileExt(fn))='.gif') then forma:=2 else forma:=3;
        end;

        //    
        if forma=1 then begin //JPEG
          jp:=TJpegImage.Create;
          Try
            jp.CompressionQuality:=TrackBar1.Position;
            jp.PixelFormat:=jf24bit;
            jp.Assign(bmp);
            jp.Compress;
            jp.SaveToFile(copy(outputfile,1,lastdelimiter('.',outputfile)-1)+'.jpg');
          finally
            jp.Free;
          end;
          Result:=copy(outputfile,1,lastdelimiter('.',outputfile)-1)+'.jpg';
        end else
        if forma=2 then begin //GIF
          gi:=TGifImage.Create;
          Try
            gi.Comment.Clear;
            gi.Comment.add('Created by Cool List Maker. TiGER grp. http://dimonius.da.ru');
            gi.Assign(bmp);
            gi.SaveToFile(copy(outputfile,1,lastdelimiter('.',outputfile)-1)+'.gif');
          finally
            gi.Free;
          end;
          Result:=copy(outputfile,1,lastdelimiter('.',outputfile)-1)+'.gif';
        end else begin //BMP
          bmp.SaveToFile(copy(outputfile,1,lastdelimiter('.',outputfile)-1)+'.bmp');
          Result:=copy(outputfile,1,lastdelimiter('.',outputfile)-1)+'.bmp';
        end;
      finally
        bmp.Free;
      end;
    end;
    except
      Result:='';
      MessageDlg('Can''t Create preview for '#10+fn,mtError,[mbOk],0);
      exit;
    end;
  finally
    im.Free;
  end;



end;

end.
